<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Authentication extends Controller {
        
        public function before() {
            parent::before();
            if(UTF8::strcasecmp($this->request->action(), 'logout'))
            {
                if(User::instance()->isSignedIn())
                {
                    $page = Request::factory(User::instance()->offsetGet('Type').'/index')->execute();
                    $this->response->body($page);
                }
            }
        }


        protected function getUpdates() {
            $fp = fopen(APPPATH.'updates.txt', 'r');
                $updates['Date'] = fgets($fp, 999);
                $updates['Text'] = '<ol>';
                if ($fp) 
                    {
                    while (!feof($fp))
                    {
                        $updates['Text'] = $updates['Text'].'<li>'.fgets($fp, 999).'</li>';
                    }
                }
                $updates['Text'] = $updates['Text'].'</ol>';
                return $updates;
        }
    
        public function action_sign()
        {
            if(!User::instance()->isSignedIn())
            {
                $type = $this->request->param('type');
                if(empty($type)) $type = 'in';
                $twig = Twig::factory('sign/'.$type);
                
                $twig->Updates = self::getUpdates();
                $this->response->body($twig);
            }
        }
        
        public function action_remind()
        {
            if(!User::instance()->isSignedIn())
            {
                $twig = Twig::factory('sign/remindpass');
                $twig->Updates = $twig->Updates = self::getUpdates();
                $this->response->body($twig);
            }
        }
        
        public function action_endremind()
        {
            $token = $this->request->param('token');
            if(!Account::instance()->checkToken($token))
                throw HTTP_Exception::factory (403, 
                        'Сожалеем, но данная ссылка для восстановления пароля более недействительна!');
            if(!User::instance()->isSignedIn())
            {
                $twig = Twig::factory('sign/changepass');
                $twig->Updates = self::getUpdates();
                $twig->Token = $token;
                $this->response->body($twig);
            }
        }
        
        public function action_logout()
        {
            User::instance()->signOut();
            $this->redirect('sign', 302);
        }

} // End Welcome
